# -*- coding: utf-8 -*-

__all__ = ["single_letter_aa", "three_letter_aa", "scop_3to1", "to_single_aa",
           "valid_ensembl_species", "valid_ensembl_species_variation"]

single_letter_aa = list('ACDEFGHIKLMNPQRSTVWY-TDHSM')

three_letter_aa = ["ALA", "CYS", "ASP", "GLU", "PHE", "GLY", "HIS", "ILE",
                   "LYS", "LEU", "MET", "ASN", "PRO", "GLN", "ARG", "SER",
                   "THR", "VAL", "TRP", "TYR", "-", 'TPO', 'PHD', 'HIC', 'SEP',
                   'MSE']

# from Bio.Data.SCOPData import protein_letters_3to1
scop_3to1 = {'CPI': 'X', 'AGM': 'R', 'G25': 'G', 'MA7': 'A', 'MA6': 'A', 'B2V': 'V', 'CPC': 'X',
             'SEN': 'S', '8FG': 'G', 'K1R': 'C', 'SIC': 'DC', 'MA ': 'A', 'ORQ': 'R', 'PTA': 'X',
             'B2I': 'I', 'MD3': 'C', 'URD': 'U', 'B2F': 'F', 'AGT': 'C', 'NYG': 'NYG', 'B2A': 'A',
             'MPH': 'X', 'TAV': 'D', 'S4G': 'G', 'S4A': 'A', 'S4C': 'C', 'UAR': 'U', 'SPT': 'T',
             'R1A': 'C', 'Z  ': 'C', '8OG': 'G', 'TAF': 'T', '5NC': 'C', 'G31': 'G', 'CSF': 'C',
             'NYS': 'C', 'TAL': 'N', 'MNL': 'L', 'KYQ': 'K', 'T41': 'T', 'RTP': 'N', 'TA4': 'X',
             'NTY': 'Y', 'PCC': 'P', 'LHC': 'X', 'BMT': 'T', 'EHP': 'F', 'CDE': 'X', 'VAF': 'V',
             '0FL': 'A', 'TIH': 'A', 'TQI': 'W', 'LHU': 'U', 'EDA': 'A', 'SBL': 'S', 'HZP': 'P',
             'D1P': 'N', 'O2C': 'N', 'BNN': 'F', 'NLO': 'L', 'AHB': 'N', 'QPA': 'C', 'NPI': 'A',
             'G2S': 'G', 'PQ1': 'N', 'SNN': 'N', 'OSE': 'S', 'AHH': 'X', 'AHO': 'A', 'PTR': 'Y',
             'MAA': 'A', 'AHS': 'X', 'AHP': 'A', 'TYO': 'Y', 'CS3': 'C', 'AHT': 'X', '01W': 'X',
             'MAI': 'R', 'CP1': 'C', 'G2L': 'G', 'FFD': 'N', 'NLN': 'L', 'XSN': 'N', 'CML': 'C',
             'M0H': 'C', '1TQ': 'W', 'ZDU': 'U', 'PCS': 'F', 'CME': 'C', 'NYM': 'N', 'HL2': 'L',
             '193': 'X', '1TY': 'Y', 'CB2': 'C', 'DTY': 'Y', '64T': 'T', '4AC': 'N', 'CSI': 'G',
             '5CM': 'C', 'CMT': 'C', 'XGU': 'G', 'CMR': 'C', 'CSH': 'SHG', 'R  ': 'A', '6MT': 'A',
             'VLL': 'X', 'C4R': 'C', 'C4S': 'C', 'TTS': 'Y', '10C': 'C', 'TTQ': 'W', 'CHG': 'X',
             'PLE': 'L', 'M2S': 'M', 'M2L': 'K', 'CSE': 'C', 'TTI': 'U', 'U2P': 'U', 'LA2': 'K',
             'MLE': 'L', 'B3U': 'H', 'KAG': 'G', 'M2G': 'G', 'T37': 'T', 'GCK': 'C', 'NMC': 'G',
             'C45': 'C', 'C46': 'C', 'AFG': 'G', 'BLY': 'K', 'C42': 'C', 'C2S': 'C', 'FTY': 'Y',
             'GCM': 'X', 'I5C': 'C', 'ALY': 'K', 'P1L': 'C', 'C49': 'C', 'DSP': 'D', 'B3Q': 'X',
             'DSN': 'S', 'MME': 'M', 'SUB': 'X', 'ZAD': 'A', 'BLE': 'L', 'DSG': 'N', 'CSB': 'C',
             'SNC': 'C', 'DLS': 'K', 'GL3': 'G', 'B3M': 'X', 'HLU': 'L', 'DT ': 'T', 'A5M': 'C',
             'A5L': 'A', 'A5O': 'A', 'A5N': 'N', 'CBR': 'C', 'SHC': 'C', 'CBV': 'C', 'QUO': 'G',
             'X4A': 'N', 'TH6': 'T', 'BE2': 'X', 'CM0': 'N', 'GLH': 'Q', 'AKZ': 'D', 'DOH': 'D',
             'GLK': 'E', '5CS': 'C', 'GLM': 'X', 'GLN': 'Q', 'T4S': 'T', 'DOC': 'C', 'T3P': 'T',
             'CSZ': 'C', 'PU ': 'A', 'FHO': 'K', 'SMP': 'A', '5CG': 'G', 'CSU': 'C', 'GLZ': 'G',
             'CTG': 'T', 'PSW': 'C', 'T32': 'T', 'AKL': 'D', 'T36': 'T', 'GLQ': 'E', '0C ': 'C',
             'CMH': 'C', 'DLY': 'K', 'T31': 'U', 'MDH': 'X', 'ONL': 'X', 'MDO': 'ASG', 'S4U': 'U',
             'HCS': 'X', 'UD5': 'U', 'B3A': 'A', 'HQA': 'A', 'TY1': 'Y', 'XTS': 'G', 'NC1': 'S',
             'MDR': 'N', 'BSE': 'S', 'P2U': 'U', '2HF': 'H', 'FCL': 'F', 'XCR': 'C', '1SC': 'C',
             'CZZ': 'C', '6IA': 'A', 'UR3': 'U', 'XTR': 'T', 'PPU': 'A', 'DFT': 'N', 'FMU': 'N',
             'SUN': 'S', 'XTY': 'N', 'D33': 'N', 'LVG': 'G', 'MVA': 'V', 'DFO': 'X', 'DFI': 'X',
             'DPY': 'N', 'HSE': 'S', 'FMG': 'G', 'DFG': 'G', 'FME': 'M', 'MD6': 'G', 'DFC': 'C',
             'XTH': 'T', 'ALN': 'A', 'ALO': 'T', 'T49': 'T', 'ALM': 'A', 'O12': 'X', '0CS': 'A',
             'RE0': 'W', 'LMS': 'N', '4SC': 'C', 'ALA': 'A', 'ORN': 'A', 'TS ': 'N', 'MMO': 'R',
             'JJL': 'C', 'JJK': 'C', 'JJJ': 'C', 'IGL': 'G', '9NE': 'E', 'ALV': 'A', 'XCP': 'X',
             'ALT': 'A', '4SU': 'U', 'KOR': 'M', 'ALS': 'A', 'LMF': 'K', 'ALQ': 'X', 'PAS': 'D',
             'IAM': 'A', 'CAY': 'C', 'DPR': 'P', 'DPQ': 'Y', 'DPP': 'A', 'CAS': 'C', 'CAR': 'C',
             'IYR': 'Y', 'CAV': 'X', 'BTC': 'C', 'MGN': 'Q', 'FHU': 'U', 'DPB': 'T', 'CAL': 'X',
             'BH2': 'D', 'CAF': 'C', 'D3 ': 'N', 'DPH': 'F', 'HIP': 'H', 'HIQ': 'H', 'ONH': 'A',
             'DPL': 'P', 'XAR': 'N', 'VAL': 'V', 'D4M': 'T', 'XCS': 'N', 'PGN': 'G', 'NHL': 'E',
             'PGL': 'X', 'TA3': 'T', '0U ': 'U', 'AVN': 'X', 'DYS': 'C', 'HIA': 'H', 'HIC': 'H',
             'XGA': 'N', 'LDH': 'K', 'IIC': 'SHG', 'AB7': 'X', 'IIL': 'I', 'D4P': 'X', 'TPH': 'X',
             'U  ': 'U', 'MGV': 'G', 'ABA': 'A', 'WCR': 'GYG', '143': 'C', 'RIA': 'A', 'TZO': 'X',
             'THR': 'T', 'PG7': 'G', 'ABR': 'A', 'ABS': 'A', '1X6': 'S', 'FVA': 'V', 'PG1': 'S',
             '2LU': 'L', 'NZH': 'H', 'AZK': 'K', '6HG': 'G', 'PG9': 'G', 'NCX': 'N', 'NCY': 'X',
             'CFL': 'C', 'SMF': 'F', '1AP': 'A', 'TFE': 'T', '23F': 'F', 'LYR': 'K', 'BHD': 'D',
             'D3P': 'G', 'PST': 'T', '9NR': 'R', 'CFY': 'FCYG', 'QLG': 'QLG', 'NCB': 'A',
             'TFQ': 'F', '2EG': 'G', '23S': 'X', 'GHP': 'G', 'MIA': 'A', 'UCL': 'U', 'TOX': 'W',
             'AP7': 'A', 'OAD': 'N', 'UDP': 'N', 'GHG': 'Q', 'FB6': 'A', 'C38': 'C', 'O2G': 'G',
             'SLZ': 'K', 'C34': 'C', 'C37': 'C', 'C36': 'C', 'C31': 'C', 'HS8': 'H', 'TY2': 'Y',
             'C32': 'C', 'CH ': 'C', '4PE': 'C', '4PD': 'C', '4PC': 'C', 'LBY': 'K', 'LP6': 'K',
             'PRO': 'P', 'PRN': 'A', '6CL': 'K', '02K': 'A', '4PH': 'F', 'FGL': 'G', 'FAI': 'N',
             '6CT': 'T', 'IAS': 'D', 'CH6': 'MYG', '6CW': 'W', 'SAR': 'G', 'FGA': 'E',
             '4F3': 'GYG', 'TPG': 'G', 'LAL': 'A', 'TDY': 'T', 'TPC': 'C', '2SI': 'X', 'CHF': 'X',
             '6MI': 'N', 'TPO': 'T', 'H5M': 'P', 'AYG': 'AYG', 'TPL': 'W', 'AYA': 'A', '2SA': 'N',
             '4FB': 'P', 'CHP': 'G', 'SOY': 'S', 'EYS': 'X', 'CHS': 'X', '6MZ': 'N', 'PR3': 'C',
             '2ST': 'T', '0NC': 'A', 'LPD': 'P', 'PR9': 'P', 'LVN': 'V', 'LMQ': 'Q', 'PYX': 'C',
             'PYY': 'N', 'THX': 'N', 'DYG': 'DYG', 'DBM': 'N', 'IPG': 'G', '0G ': 'G', 'GH3': 'G',
             'APP': 'X', 'DBB': 'T', 'IPN': 'N', 'TYB': 'Y', 'MBQ': 'Y', 'DBY': 'Y', 'APK': 'K',
             'APH': 'A', 'API': 'K', 'C3Y': 'C', 'TYY': 'Y', 'APM': 'X', 'M5M': 'C', '4OC': 'C',
             'DBS': 'S', 'PGY': 'G', 'DBU': 'T', 'TYQ': 'Y', 'TYR': 'Y', 'APE': 'X', 'BT5': 'N',
             '2AG': 'A', '2AD': 'X', 'ZTH': 'T', 'HDP': 'U', 'CZ2': 'C', '2AO': 'X', 'XX1': 'K',
             'JW5': 'N', 'OCY': 'C', 'P2T': 'T', '2AT': 'T', '2AU': 'U', '2AR': 'A', '2AS': 'X',
             'G46': 'G', 'G47': 'G', 'G48': 'G', 'G49': 'G', 'OCS': 'C', 'P2Y': 'P', 'NLQ': 'Q',
             'NLP': 'L', 'CEA': 'C', 'HV5': 'A', 'HMR': 'R', 'IG ': 'G', 'MTR': 'T', 'BMP': 'N',
             'NLE': 'L', 'CS8': 'N', '2FE': 'N', 'YOF': 'Y', 'CS4': 'C', '2FI': 'N', 'IT1': 'K',
             'CS1': 'C', 'CS0': 'C', '2FM': 'M', 'MAD': 'A', 'SHP': 'G', 'CSL': 'C', 'CSO': 'C',
             'B3X': 'N', 'B3Y': 'Y', 'DLE': 'L', 'CSJ': 'C', 'B3T': 'X', '5FA': 'A', 'AFF': 'N',
             '5FC': 'C', 'CSA': 'C', 'AFA': 'N', 'B3S': 'S', 'B3L': 'X', 'A47': 'A', 'A44': 'A',
             'HTN': 'N', 'CSY': 'SYG', 'A43': 'A', 'A40': 'A', 'B3K': 'K', 'B3D': 'D', 'B3E': 'E',
             'CSW': 'C', 'FA5': 'N', '5FU': 'U', 'CSS': 'C', '0YG': 'YG', '5MU': 'U', 'N10': 'S',
             'MGG': 'R', 'ASU': 'N', 'TGP': 'G', 'BTR': 'W', 'SSU': 'U', '70U': 'U', 'SEP': 'S',
             'XCN': 'C', 'HGL': 'X', 'XCL': 'C', 'G4P': 'N', '5MD': 'N', 'MGQ': 'A', 'BTA': 'L',
             'CZO': 'GYG', '5MC': 'C', 'ABT': 'N', 'MGY': 'G', 'XCY': 'C', 'DGH': 'G', 'CY0': 'C',
             'TLC': 'T', 'ATD': 'T', 'A38': 'A', 'M1G': 'G', 'TYU': 'N', 'SLR': 'P', '2TL': 'T',
             'ATL': 'T', 'ATM': 'T', 'PVH': 'H', 'R4K': 'W', 'PEC': 'C', 'TP1': 'T', 'DTH': 'T',
             'XUA': 'A', 'NPH': 'C', '175': 'ASG', '2TY': 'Y', 'CRW': 'ASG', 'UN1': 'X',
             'ASQ': 'D', 'ASP': 'D', 'ECC': 'Q', 'SER': 'S', 'A35': 'A', 'A34': 'A', 'DU ': 'U',
             'P5P': 'A', 'A39': 'A', '0DT': 'T', 'DGN': 'Q', 'DGL': 'E', 'STY': 'Y', 'SEG': 'A',
             'ASB': 'D', 'ASA': 'D', 'TDD': 'L', 'SEC': 'A', 'SEB': 'S', 'BB9': 'C', 'BB8': 'F',
             '0DG': 'G', 'BB6': 'C', 'ASI': 'D', 'SEL': 'S', '0DC': 'C', 'ASN': 'N', 'ASM': 'X',
             'ASL': 'D', 'AS2': 'D', 'DG ': 'G', 'A3P': 'A', 'CLH': 'K', '3DR': 'N', 'FRD': 'X',
             'CLE': 'L', 'AS9': 'X', 'CLG': 'K', 'BBC': 'C', 'IML': 'I', 'GTP': 'G', 'ASK': 'D',
             'A3A': 'A', 'AS ': 'A', 'OXX': 'D', '3DA': 'A', 'GT9': 'C', 'SHR': 'K', 'SDP': 'S',
             'CLV': 'AFG', 'UNK': 'X', 'SEM': 'S', '4BF': 'Y', 'OMC': 'C', 'OMG': 'G', 'H2U': 'U',
             'SGB': 'S', 'PVL': 'X', 'I58': 'K', 'GGL': 'E', 'OMT': 'M', 'DMT': 'X', 'XYG': 'DYG',
             'D3T': 'T', 'T11': 'F', '2MR': 'R', 'L2A': 'X', '5IC': 'C', 'T66': 'X', 'BPE': 'C',
             '2MT': 'P', '2MU': 'U', '3XH': 'G', 'GLJ': 'E', 'IMC': 'C', 'SWG': 'SWG', 'AEI': 'D',
             '2MA': 'A', '5IU': 'U', '2MG': 'G', 'AAR': 'R', 'C  ': 'C', 'TST': 'X', '2ML': 'L',
             'CYS': 'C', 'CYR': 'C', 'BIL': 'X', 'PCA': 'E', 'GYC': 'CYG', 'SMC': 'C', 'S2D': 'A',
             'BIF': 'F', '2BU': 'A', '2BT': 'T', '5PC': 'C', '4U7': 'A', 'ML3': 'K', 'CYA': 'C',
             'HY3': 'P', 'CYG': 'C', 'CYF': 'C', '5PY': 'T', 'U8U': 'U', 'CYJ': 'X', '2BD': 'I',
             'ENP': 'N', 'PDU': 'U', 'CYM': 'C', 'TT ': 'N', 'CY3': 'C', '200': 'F', 'CY1': 'C',
             'CR7': 'KYG', 'DHI': 'H', 'CY4': 'C', 'CWR': 'S', 'XXY': 'THG', 'DHA': 'S',
             'IZO': 'M', '32S': 'X', 'CSX': 'C', '3QN': 'K', '32T': 'X', 'T5O': 'U', 'MLZ': 'K',
             'DHV': 'V', 'DHU': 'U', 'MLY': 'K', 'SLA': 'P', 'DHP': 'X', 'OTH': 'T', 'E1X': 'A',
             'XGL': 'G', 'MCL': 'K', 'U2L': 'U', 'TLB': 'N', 'MCG': 'X', 'OTB': 'X', 'FT6': 'W',
             'ARM': 'R', 'HOL': 'N', 'AA4': 'A', 'PDL': 'X', 'NYC': 'TWG', 'AA3': 'A', 'LSO': 'X',
             'E  ': 'A', 'LGP': 'G', 'MK8': 'L', 'MCS': 'C', 'U2N': 'U', 'PAQ': 'Y', '2PR': 'G',
             'EXB': 'X', 'PAU': 'A', 'PUY': 'N', 'TYJ': 'Y', '9NV': 'V', '3CF': 'F', 'DZM': 'A',
             'BGM': 'G', 'GMS': 'G', 'DRZ': 'N', 'TQQ': 'W', '2PI': 'X', 'GSU': 'E', 'DMH': 'N',
             'TCQ': 'Y', 'DHN': 'V', 'EXY': 'L', 'ZHP': 'N', '12A': 'A', 'DCL': 'X', 'X  ': 'G',
             'DCI': 'X', 'RE3': 'W', 'DCG': 'G', '4HT': 'W', 'HSO': 'H', 'HSL': 'S', 'TLN': 'U',
             'TZB': 'X', 'DCY': 'C', 'DCT': 'C', 'C2L': 'C', 'NF2': 'N', 'GPL': 'K', 'GDP': 'G',
             'THZ': 'R', 'RT ': 'T', 'C25': 'C', 'N2C': 'X', 'LAA': 'D', 'HAC': 'A', 'KNB': 'A',
             'MEG': 'E', 'DC ': 'C', 'THO': 'X', 'SCY': 'C', 'BNO': 'X', '125': 'U', '126': 'U',
             '127': 'U', '128': 'N', 'MEA': 'F', 'HAR': 'R', 'HS9': 'H', 'DC2': 'C', 'HRP': 'W',
             'IAR': 'R', 'PHI': 'F', 'F2F': 'F', 'PHM': 'F', 'PHL': 'F', 'PHA': 'F', 'OIC': 'X',
             'PHE': 'F', 'PHD': 'D', 'SYS': 'C', 'BG1': 'S', 'NIY': 'Y', 'ZAL': 'A', 'OAS': 'S',
             'X2W': 'E', 'TTD': 'T', 'N  ': 'N', 'NIT': 'X', 'OIP': 'I', '0A0': 'D', '0A1': 'Y',
             '0A2': 'K', 'CRQ': 'QYG', 'AET': 'A', 'CRU': 'EYG', '0A8': 'C', 'CRX': 'ASG',
             'DMK': 'D', 'IGU': 'G', '7JA': 'I', 'AEA': 'X', 'LPL': 'X', 'FTR': 'W', 'CRF': 'TWG',
             'CRG': 'THG', 'LC ': 'C', 'TY5': 'Y', '1MA': 'A', 'CRK': 'MYG', 'SDG': 'G',
             'AN8': 'A', 'CRO': 'GYG', '1MG': 'G', 'PAT': 'W', 'MIS': 'S', 'MFC': 'GYG',
             'NFA': 'F', 'YRR': 'N', 'TCY': 'A', 'G7M': 'G', 'S6G': 'G', 'C43': 'C', 'TCR': 'W',
             'TCP': 'T', 'BOE': 'T', 'MEQ': 'Q', '8AN': 'A', 'IU ': 'U', 'BUC': 'C', 'TY3': 'Y',
             '7MG': 'G', 'BUG': 'V', 'MEP': 'U', 'MHO': 'M', 'CSP': 'C', 'DDX': 'N', 'OMU': 'U',
             'LME': 'E', 'FOX': 'G', 'QPH': 'F', 'MTY': 'Y', 'TC1': 'C', 'HBN': 'H', 'FOE': 'C',
             'MF3': 'X', 'DDN': 'U', 'TFO': 'A', 'EFC': 'C', 'DDG': 'G', 'MHS': 'H', 'DDE': 'H',
             '0AP': 'C', 'P1P': 'N', 'CR0': 'TLG', '0AU': 'U', '0AV': 'A', 'CR5': 'G', 'ASX': 'B',
             '0AZ': 'P', 'NNH': 'R', 'LCX': 'K', 'VMS': 'X', 'DM0': 'K', '0AA': 'V', '0AB': 'V',
             '03Y': 'C', '0AD': 'G', 'LCC': 'N', '0AF': 'W', '0AG': 'L', '0AH': 'S', 'XTL': 'T',
             '0AK': 'D', '0AM': 'A', 'CSR': 'C', 'MOD': 'X', 'ILG': 'E', 'ILE': 'I', 'D11': 'T',
             'UMS': 'U', '4CY': 'M', 'FGP': 'S', 'DVA': 'V', '5ZA': 'TWG', 'TMB': 'T', '3AH': 'H',
             'TMD': 'T', 'TNR': 'S', 'KPI': 'K', '3GA': 'A', 'A2L': 'A', 'A2M': 'A', 'ILX': 'I',
             'BCS': 'C', 'DSE': 'S', 'ZBC': 'C', 'OLE': 'X', 'LPG': 'G', 'YG ': 'G', 'GLX': 'Z',
             'ZBU': 'U', 'OLT': 'T', 'TBM': 'T', 'EY5': 'N', 'OLZ': 'S', 'C6C': 'C', 'IEY': 'HYG',
             'CR2': 'GYG', 'ZGU': 'G', 'SRA': 'A', 'M3L': 'K', 'PRS': 'P', 'NDN': 'U', 'C66': 'X',
             'DHL': 'X', 'CH7': 'KYG', 'GLY': 'G', 'PSH': 'H', 'NDF': 'F', 'N6G': 'G', 'S1H': 'S',
             'FZN': 'K', 'LYM': 'K', '0SP': 'A', 'OBS': 'X', '2NT': 'T', '7DA': 'A', '5SE': 'U',
             'A23': 'A', '2GT': 'T', 'NMS': 'T', 'CIR': 'R', 'TFT': 'T', 'TPQ': 'Y', 'BJH': 'X',
             'XAL': 'A', 'CDV': 'X', 'CDW': 'C', 'ZFB': 'X', 'I2M': 'I', 'UFP': 'N', 'SET': 'S',
             'UFR': 'U', 'NMM': 'R', 'UFT': 'U', 'CR8': 'HYG', '5IT': 'T', 'DIL': 'I', 'FHL': 'X',
             'AR2': 'R', 'PSA': 'F', 'AR4': 'E', 'EIT': 'T', 'SD2': 'X', 'AR7': 'R', 'Z01': 'A',
             'A  ': 'A', 'N5I': 'N', '5AT': 'T', 'HYP': 'P', 'IYT': 'T', 'MG1': 'G', 'ONE': 'U',
             'GND': 'X', 'GNE': 'N', '5AA': 'A', 'C12': 'TYG', 'DIV': 'V', '5AB': 'A', 'T6A': 'A',
             'DIR': 'R', 'AIB': 'A', '00C': 'C', 'SOC': 'C', 'G32': 'G', 'LCG': 'G', 'MT2': 'M',
             'GAU': 'E', 'BFD': 'D', 'U33': 'U', 'PPN': 'F', 'QMM': 'Q', 'GAO': 'G', 'SOS': 'N',
             '0AC': 'G', 'PPW': 'G', 'MC1': 'S', 'MBZ': 'N', 'OHS': 'D', 'DTR': 'W', 'US5': 'U',
             'FAG': 'N', '3NF': 'Y', 'G33': 'G', '6OG': 'G', 'NVA': 'V', 'TYS': 'Y', 'G36': 'G',
             'FA2': 'A', 'G38': 'G', 'HPQ': 'F', 'LCA': 'A', 'CYQ': 'C', 'LG ': 'G', '6MC': 'A',
             'HVA': 'V', 'I  ': 'I', 'HPH': 'F', 'IRN': 'N', 'HPC': 'F', '4DP': 'W', 'HPE': 'F',
             'PR5': 'A', 'HRG': 'R', 'GN7': 'G', 'ARV': 'X', 'RC7': 'HYG', 'DI ': 'I', 'LCK': 'K',
             'S2C': 'C', 'C1X': 'K', 'LCH': 'N', '4MF': 'N', 'ARG': 'R', '07O': 'C', 'PSU': 'U',
             '4MM': 'X', 'ARO': 'R', 'GSS': 'G', '8MG': 'G', 'CCY': 'CYG', 'SVX': 'S', 'DRP': 'N',
             'BOR': 'R', 'XCT': 'C', 'DRT': 'T', 'CCS': 'C', 'NAM': 'A', 'CCL': 'K', 'GSC': 'G',
             'VLM': 'X', 'DRM': 'U', 'SVW': 'S', 'SMT': 'T', 'DON': 'L', 'NAL': 'A', 'S2M': 'T',
             '4FW': 'W', 'CCC': 'C', 'UMP': 'U', 'U37': 'U', '26B': 'T', 'MRG': 'G', 'OHI': 'H',
             'IOY': 'F', 'LYS': 'K', '2XA': 'C', 'PIA': 'AYG', 'LYX': 'K', 'S2P': 'A', 'LYZ': 'K',
             'ODP': 'N', 'LYF': 'K', 'POM': 'P', 'MTU': 'A', 'GYS': 'SYG', 'LYN': 'K', 'PIV': 'X',
             'LYK': 'K', 'DOA': 'X', 'LEM': 'L', 'U25': 'U', 'CYD': 'C', 'TYN': 'Y', 'SVA': 'S',
             '5HT': 'T', '5HU': 'U', 'SVZ': 'X', '5HP': 'E', 'SVY': 'S', 'SVV': 'S', 'CQR': 'GYG',
             'XAD': 'A', 'XAE': 'N', 'TYI': 'Y', 'BZG': 'N', 'BIU': 'I', 'TTM': 'T', 'CTE': 'W',
             'MHL': 'L', 'A66': 'X', 'XGR': 'G', 'GS ': 'G', '2CO': 'C', 'VB1': 'K', 'XPR': 'P',
             'UMA': 'A', 'NA8': 'A', 'CXM': 'M', 'GOM': 'G', '2VA': 'V', 'T38': 'T', '5BU': 'U',
             'SIB': 'C', 'T39': 'T', 'FLT': 'Y', 'M30': 'G', 'NP3': 'N', '4CF': 'F', 'BVP': 'U',
             'TYT': 'Y', 'U31': 'U', 'ALC': 'A', 'FLA': 'A', 'FPA': 'F', 'FLE': 'L', '4TA': 'N',
             'MP8': 'P', 'LLY': 'K', 'SCH': 'C', 'RON': 'X', 'PTH': 'Y', 'CTH': 'T', 'LLP': 'K',
             'MNU': 'U', 'MNV': 'V', 'BB7': 'C', 'THC': 'T', 'DBZ': 'A', 'GLU': 'E', 'T  ': 'T',
             'TYX': 'X', 'T2S': 'T', '0BN': 'F', 'MND': 'N', '3TY': 'X', 'SCS': 'C', 'PBT': 'N',
             'T5S': 'T', 'CJO': 'GYG', 'TRO': 'W', 'TRN': 'W', 'PYO': 'U', 'SC ': 'C', 'TRG': 'K',
             'TRF': 'W', 'TRX': 'W', 'PBF': 'F', 'MLL': 'L', 'YCM': 'C', 'PBB': 'C', 'TRQ': 'W',
             'TRP': 'W', 'T23': 'T', 'TRW': 'W', 'TYW': 'Y', 'MCY': 'C', 'VOL': 'X', '6HT': 'T',
             '9NF': 'F', 'MPJ': 'X', 'HIS': 'H', 'HTI': 'C', '4IN': 'W', '6HN': 'K', 'C5C': 'C',
             'HTR': 'W', 'MPQ': 'G', '3ME': 'U', '3MD': 'D', '6HA': 'A', 'KCX': 'K', '6HC': 'C',
             'AVC': 'A', 'ACB': 'D', 'NEM': 'H', 'N7P': 'P', '2OM': 'U', 'FB5': 'A', 'KST': 'K',
             'CSD': 'C', 'SUI': 'DG', 'ACL': 'R', 'P  ': 'G', 'SUR': 'U', 'T48': 'T', 'HFA': 'X',
             '2OT': 'T', 'NEP': 'H', 'PMT': 'C', '2DT': 'T', 'AD2': 'A', 'DN ': 'N', 'CGA': 'E',
             'NBQ': 'Y', 'NSK': 'X', '7GU': 'G', 'SAH': 'C', '2DF': 'N', '2DA': 'A', 'ZZJ': 'A',
             '2DM': 'N', '56A': 'H', '2DO': 'X', 'CGU': 'E', 'YYG': 'G', 'DNE': 'L', 'DNG': 'L',
             'NB8': 'N', 'PM3': 'F', 'DNM': 'L', 'DNL': 'K', 'GMA': 'E', 'ADX': 'N', 'LKC': 'N',
             'ADD': 'X', 'CUC': 'X', 'DNP': 'A', 'DNS': 'K', 'DNR': 'C', 'CG1': 'G', '6MA': 'A',
             'N5M': 'C', 'GMU': 'U', 'VAD': 'V', 'B1F': 'F', 'MED': 'M', 'GDR': 'G', 'ZU0': 'T',
             'LED': 'L', 'LEF': 'L', 'U36': 'U', 'LEH': 'L', 'LEI': 'V', 'BRU': 'U', 'MEN': 'N',
             'G42': 'G', 'LEN': 'L', 'MEU': 'G', 'MET': 'M', 'U34': 'U', 'LET': 'X', 'LEU': 'L',
             'B1P': 'N', 'LEX': 'L', 'PYA': 'A', 'X9Q': 'AFG', '1PI': 'A', 'HEU': 'U', 'USM': 'U',
             '1PA': 'F', 'MSP': 'X', 'MSO': 'M', 'AZY': 'Y', 'MSL': 'M', 'PF5': 'F', '1PR': 'N',
             '3AR': 'X', 'MSE': 'M', 'AZS': 'S', 'MSA': 'G', 'MMT': 'T', 'DAB': 'A', 'OTY': 'Y',
             'DAL': 'A', 'LTR': 'W', '08P': 'C', 'DAH': 'F', 'OPR': 'R', 'TBG': 'V', 'VDL': 'X',
             'OBF': 'X', 'DAR': 'R', 'DAS': 'D', 'GFL': 'G', 'IC ': 'C', 'FP9': 'P', 'UN2': 'X',
             'GSR': 'G', 'CNU': 'U', 'DA ': 'A', 'A1P': 'N', 'GVL': 'X', 'SAC': 'S', 'LPS': 'S',
             'C99': 'TFG', 'PTM': 'Y', 'XUG': 'G', 'ESC': 'M', 'ESB': 'Y', 'DA2': 'X', 'TNB': 'C',
             'RMP': 'A', 'SME': 'M', 'NRQ': 'MYG', 'T2T': 'N', 'NRP': 'LYG', 'PFF': 'F',
             'ZCL': 'F', 'DGI': 'G', 'PCE': 'X', 'LTA': 'X', 'PGP': 'G', 'DXN': 'N', 'KGC': 'K',
             'US3': 'T', 'US2': 'U', 'US1': 'U', 'Y  ': 'A', 'HHK': 'AK', 'PFX': 'X', 'HHI': 'H',
             'DXD': 'N', 'G  ': 'G', 'ZCY': 'C', 'NMT': 'T', 'IEL': 'K'}

to_single_aa = dict(zip(three_letter_aa, single_letter_aa))

# Asx	B	Aspartic acid or Asparagine
# Glx	Z	Glutamic acid or Glutamine
# Xaa	X	Any amino acid
# Xle	J	Leucine or Isoleucine
aa_codes_1to3_extended = {
    'A': 'ALA', 'C': 'CYS', 'D': 'ASP',
    'E': 'GLU', 'F': 'PHE', 'G': 'GLY',
    'H': 'HIS', 'K': 'LYS', 'I': 'ILE',
    'L': 'LEU', 'M': 'MET', 'N': 'ASN',
    'P': 'PRO', 'Q': 'GLN', 'R': 'ARG',
    'S': 'SER', 'T': 'THR', 'V': 'VAL',
    'Y': 'TYR', 'W': 'TRP',
    'X': 'LNT', 'B': 'ASX', 'Z': 'GLX',
    'J': 'XLE', 'U': 'SEC', 'O': 'PYL',
    '-': '---',
}

aa_default_atoms = {
    'ALA': ['N', 'O', 'CA', 'C', 'CB'],
    'CYS': ['N', 'O', 'CA', 'C', 'SG', 'CB'],
    'ASP': ['N', 'O', 'CA', 'C', 'CG', 'OD2', 'OD1', 'CB'],
    'GLU': ['N', 'O', 'CA', 'C', 'CD', 'CG', 'OE1', 'CB', 'OE2'],
    'PHE': ['N', 'O', 'CA', 'C', 'CE1', 'CD1', 'CZ', 'CG', 'CB', 'CE2', 'CD2'],
    'GLY': ['N', 'O', 'CA', 'C'],
    'HIS': ['N', 'O', 'CA', 'C', 'CB', 'CG', 'ND1', 'CD2', 'CE1', 'NE2'],
    'LYS': ['N', 'O', 'CA', 'C', 'NZ', 'CD', 'CE', 'CG', 'CB'],
    'ILE': ['N', 'O', 'CA', 'C', 'CG2', 'CD1', 'CB', 'CG1'],
    'LEU': ['N', 'O', 'CA', 'C', 'CD2', 'CD1', 'CG', 'CB'],
    'MET': ['N', 'O', 'CA', 'C', 'SD', 'CG', 'CB', 'CE'],
    'ASN': ['N', 'O', 'CA', 'C', 'ND2', 'OD1', 'CB', 'CG'],
    'PRO': ['N', 'O', 'CA', 'C', 'CD', 'CG', 'CB'],
    'GLN': ['N', 'O', 'CA', 'C', 'CD', 'NE2', 'OE1', 'CB', 'CG'],
    'ARG': ['N', 'O', 'CA', 'C', 'CZ', 'CD', 'NE', 'CG', 'CB'],
    'SER': ['N', 'O', 'CA', 'C', 'CB', 'OG'],
    'THR': ['N', 'O', 'CA', 'C', 'OG1', 'CG2', 'CB'],
    'VAL': ['N', 'O', 'CA', 'C', 'CB', 'CG2', 'CG1'],
    'TYR': ['N', 'O', 'CA', 'C', 'CE1', 'CD1', 'CZ', 'CG', 'CB', 'CE2', 'CD2'],
    'TRP': ['N', 'O', 'CA', 'C', 'NE1', 'CZ3', 'CD1', 'CE3', 'CG', 'CB', 'CZ2', 'CE2', 'CD2'],
}

# obtained from biopython at
# https://github.com/biopython/biopython/blob/master/Bio/PDB/DSSP.py
# Miller max acc: Miller et al. 1987 http://dx.doi.org/10.1016/0022-2836(87)90038-6
# Wilke: Tien et al. 2013 http://dx.doi.org/10.1371/journal.pone.0080635
# Sander: Sander & Rost 1994 http://dx.doi.org/10.1002/prot.340200303
ASA_Miller = {
    'ALA': 113.0, 'ARG': 241.0, 'ASN': 158.0, 'ASP': 151.0,
    'CYS': 140.0, 'GLN': 189.0, 'GLU': 183.0, 'GLY': 85.0,
    'HIS': 194.0, 'ILE': 182.0, 'LEU': 180.0, 'LYS': 211.0,
    'MET': 204.0, 'PHE': 218.0, 'PRO': 143.0, 'SER': 122.0,
    'THR': 146.0, 'TRP': 259.0, 'TYR': 229.0, 'VAL': 160.0
}

ASA_Wilke = {
    'ALA': 129.0, 'ARG': 274.0, 'ASN': 195.0, 'ASP': 193.0,
    'CYS': 167.0, 'GLN': 225.0, 'GLU': 223.0, 'GLY': 104.0,
    'HIS': 224.0, 'ILE': 197.0, 'LEU': 201.0, 'LYS': 236.0,
    'MET': 224.0, 'PHE': 240.0, 'PRO': 159.0, 'SER': 155.0,
    'THR': 172.0, 'TRP': 285.0, 'TYR': 263.0, 'VAL': 174.0
}

ASA_Sander = {
    'ALA': 106.0, 'ARG': 248.0, 'ASN': 157.0, 'ASP': 163.0,
    'CYS': 135.0, 'GLN': 198.0, 'GLU': 194.0, 'GLY': 84.0,
    'HIS': 184.0, 'ILE': 169.0, 'LEU': 164.0, 'LYS': 205.0,
    'MET': 188.0, 'PHE': 197.0, 'PRO': 136.0, 'SER': 130.0,
    'THR': 142.0, 'TRP': 227.0, 'TYR': 222.0, 'VAL': 142.0
}

# taken from http://www.ensembl.org/info/about/species.html
# on 10.08.2015
valid_ensembl_species = ['orycteropus_afer_afer',
                         'vicugna_pacos',
                         'poecilia_formosa',
                         'anolis_carolinensis',
                         'dasypus_novemcinctus',
                         'melopsittacus_undulatus',
                         'otolemur_garnettii',
                         'ciona_intestinalis',
                         'ciona_savignyi',
                         'caenorhabditis_elegans',
                         'felis_catus',
                         'astyanax_mexicanus',
                         'gallus_gallus',
                         'pan_troglodytes',
                         'pan_troglodytes',
                         'cricetulus_griseus',
                         'pelodiscus_sinensis',
                         'gadus_morhua',
                         'latimeria_chalumnae',
                         'bos_taurus',
                         'macaca_fascicularis',
                         'canis_lupus_familiaris',
                         'tursiops_truncatus',
                         'tursiops_truncatus',
                         'anas_platyrhynchos',
                         'loxodonta_africana',
                         'mustela_putorius_furo',
                         'ficedula_albicollis',
                         'drosophila_melanogaster',
                         'takifugu_rubripes',
                         'takifugu_rubripes',
                         'nomascus_leucogenys',
                         'gorilla_gorilla_gorilla',
                         'cavia_porcellus',
                         'papio_hamadryas',
                         'erinaceus_europaeus',
                         'erinaceus_europaeus',
                         'equus_caballus',
                         'homo_sapiens', 'human',
                         'procavia_capensis',
                         'dipodomys_ordii',
                         'petromyzon_marinus',
                         'echinops_telfairi',
                         'macaca_mulatta',
                         'callithrix_jacchus',
                         'oryzias_latipes',
                         'pteropus_vampyrus',
                         'myotis_lucifugus',
                         'mus_musculus',
                         'microcebus_murinus',
                         'heterocephalus_glaber',
                         'papio_anubis',
                         'monodelphis_domestica',
                         'pongo_abelii',
                         'chrysemys_picta_bellii',
                         'ailuropoda_melanoleuca',
                         'sus_scrofa',
                         'sus_scrofa_map',
                         'ochotona_princeps',
                         'ochotona_princeps',
                         'xiphophorus_maculatus',
                         'ornithorhynchus_anatinus',
                         'microtus_ochrogaster',
                         'oryctolagus_cuniculus',
                         'rattus_norvegicus',
                         'ceratotherium_simum_simum',
                         'saccharomyces_cerevisiae',
                         'ovis_aries',
                         'sorex_araneus',
                         'sorex_araneus',
                         'choloepus_hoffmanni',
                         'physter_macrocephalus',
                         'lepisosteus_oculatus',
                         'ictidomys_tridecemlineatus',
                         'saimiri_boliviensis',
                         'gasterosteus_aculeatus',
                         'tarsius_syrichta',
                         'sarcophilus_harrisii',
                         'tetraodon_nigroviridis',
                         'oreochromis_niloticus',
                         'tupaia_belangeri',
                         'meleagris_gallopavo',
                         'chlorocebus_sabaeus',
                         'macropus_eugenii',
                         'xenopus_tropicalis',
                         'taeniopygia_guttata',
                         'danio_rerio']

# taken from http://www.ensembl.org/info/genome/variation/data_description.html
# on 10.08.2015
valid_ensembl_species_variation = ['bos_taurus',
                                   'canis_familiaris',
                                   'danio_rerio',
                                   'drosophila_melanogaster',
                                   'equus_caballus',
                                   'felis_catus',
                                   'gallus_gallus',
                                   'homo_sapiens', 'human',
                                   'macaca_mulatta',
                                   'meleagris_gallopavo',
                                   'monodelphis_domestica',
                                   'mus_musculus',
                                   'nomascus_leucogenys',
                                   'ornithorhynchus_anatinus',
                                   'ovis_aries',
                                   'pan_troglodytes',
                                   'pongo_abelii',
                                   'rattus_norvegicus',
                                   'saccharomyces_cerevisiae',
                                   'tetraodon_nigroviridis']

_convert_dtypes = {
    int: 'int64',
    float: 'float64',
    str: 'object'
}

_pdbx_types = {
    'group_PDB': str,
    'id': int,
    'type_symbol': str,
    'label_atom_id': str,
    'label_alt_id': str,
    'label_comp_id': str,
    'label_asym_id': str,
    'label_entity_id': str,
    'label_seq_id': str,
    'new_asym_id': str,
    'new_seq_id': str,
    'pdbx_PDB_ins_code': str,
    'Cartn_x': float,
    'Cartn_y': float,
    'Cartn_z': float,
    'occupancy': float,
    'B_iso_or_equiv': float,
    'Cartn_x_esd': float,
    'Cartn_y_esd': float,
    'Cartn_z_esd': float,
    'occupancy_esd': float,
    'B_iso_or_equiv_esd': float,
    'pdbx_formal_charge': int,
    'auth_seq_id': str,
    'auth_comp_id': str,
    'auth_asym_id': str,
    'auth_atom_id': str,
    'pdbx_PDB_model_num': str,
    'pdbe_label_seq_id': str,
    'orig_label_asym_id': str,
    'orig_auth_asym_id': str,
    'auth_seq_id_full': str,
    'label_seq_id_full': str,
    'contact_indexes': str,
}

_dssp_types = {
    'LINE': int,
    'RES': str,
    'RES_FULL': str,
    'CHAIN': str,
    'CHAIN_FULL': str,
    'INSCODE': str,
    'AA': str,
    'SS': str,
    'SS_CLASS': str,
    'STRUCTURE': str,
    'BP1': str,
    'BP2': str,
    'BP2_CHAIN': str,
    'ACC': int,
    'RSA': float,
    'RSA_CLASS': str,
    'NH_O_1': int,
    'NH_O_1_nrg': float,
    'O_HN_1': int,
    'O_HN_1_nrg': float,
    'NH_O_2': int,
    'NH_O_2_nrg': float,
    'O_HN_2': int,
    'O_HN_2_nrg': float,
    'TCO': float,
    'KAPPA': float,
    'ALPHA': float,
    'PHI': float,
    'PSI': float,
    'X-CA': float,
    'Y-CA': float,
    'Z-CA': float
}

_sifts_types = {
    'PDB_regionId': int,
    'PDB_regionStart': int,
    'PDB_regionEnd': int,
    'PDB_regionResNum': str,
    'PDB_dbVersion': str,
    'PDB_dbAccessionId': str,
    'PDB_dbResNum': str,
    'PDB_dbResName': str,
    'PDB_dbChainId': str,
    'PDB_Annotation': str,
    'PDB_entityId': str,
    'PDB_codeSecondaryStructure': str,
    'PDB_nameSecondaryStructure': str,
    'UniProt_regionId': int,
    'UniProt_regionStart': int,
    'UniProt_regionEnd': int,
    'UniProt_regionResNum': str,
    'UniProt_dbVersion': str,
    'UniProt_dbAccessionId': str,
    'UniProt_dbResNum': str,
    'UniProt_dbResName': str,
    'CATH_regionId': int,
    'CATH_regionStart': int,
    'CATH_regionEnd': int,
    'CATH_regionResNum': str,
    'CATH_dbVersion': str,
    'CATH_dbAccessionId': str,
    'SCOP_regionId': int,
    'SCOP_regionStart': int,
    'SCOP_regionEnd': int,
    'SCOP_regionResNum': str,
    'SCOP_dbVersion': str,
    'SCOP_dbAccessionId': str,
    'Pfam_regionId': int,
    'Pfam_regionStart': int,
    'Pfam_regionEnd': int,
    'Pfam_regionResNum': str,
    'Pfam_dbVersion': str,
    'Pfam_dbAccessionId': str
}

_validation_types = {
    'validation_model': int,
    'validation_ent': str,
    'validation_chain': str,
    'validation_resname': str,
    'validation_resnum': str,
    'validation_resnum_full': str,
    'validation_seq': str,
    'validation_altcode': str,
    'validation_icode': str,
    'validation_ligRSRZ': str,
    'validation_ligRSRnbrMean': str,
    'validation_ligRSRnbrStdev': str,
    'validation_ligRSRnumnbrs': str,
    'validation_avgoccu': float,
    'validation_rota': str,
    'validation_rsr': float,
    'validation_owab': float,
    'validation_rsrz': str,
    'validation_num-H-reduce': str,
    'validation_rama': str,
    'validation_said': str,
    'validation_NatomsEDS': int,
    'validation_flippable-sidechain': str,
    'validation_rscc': float,
    'validation_phi': float,
    'validation_psi': float,
    'validation_mogul-ignore': str
}

_annotation_types = {
    'empty': str,
    'END': str,
    'FRAME': str,
    'GROUP': str,
    'ID': str,
    'NAME': str,
    'NOTE': str,
    'SCORE': str,
    'SOURCE': str,
    'START': str,
    'STRAND': str,
    'TYPE': str,
    'site': str,
    'accession': str
}

_uni_ens_var_types = {
    'begin': int,
    'end': int,
    'polyphenScore': float,
    'siftScore': float,
}

pdbx_types = {k: _convert_dtypes[v] for k, v in _pdbx_types.items()}
dssp_types = {k: _convert_dtypes[v] for k, v in _dssp_types.items()}
sifts_types = {k: _convert_dtypes[v] for k, v in _sifts_types.items()}
validation_types = {k: _convert_dtypes[v] for k, v in _validation_types.items()}
annotation_types = {k: _convert_dtypes[v] for k, v in _annotation_types.items()}
uni_ens_var_types = {k: _convert_dtypes[v] for k, v in _uni_ens_var_types.items()}

# updating terms in ensembl output so that they match
# UniProt Proteins API counterparts
update_ensembl_to_uniprot = {
    'minor_allele_frequency': 'frequency',
    'start': 'begin',
    'end': 'end',
    'sift': 'siftScore',
    'polyphen': 'polyphenScore',
    'type': 'consequenceType',
    'id': 'xrefs_id'
}

